      '************************************************************
     '*       LAP COUNTER AND TIMER FOR RC CARS                      *
     '*       CREATED BY ALONZO TRUELAND                                  *
     '*       JULY 12,2002  V1.0                                                                 *
     '*       atrueland@yahoo.com                                                               *
     '*************************************************************
$crystal = 4000000

Config Timer1 = Timer , Prescale = 1024 , Capture Edge = Falling , Noice Cancel = 1
Config Graphlcd = 240 * 128 , Dataport = Portb , Controlport = Portc , Ce = 2 , Cd = 3 , Wr = 0 , Rd = 1 , Reset = 4 , Fs = 5 , Mode = 8
Cls                                     'clear display
'--set-up isr routines--
On Int0 Isr_int0
On Capture1 Isr_cap1
On Timer1 Isr_tim1
'-----------------------

Config Pina.0 = Output
Config Pind.6 = Input                   'input of beam detector
Config Int0 = Falling                   'stop/review button input

'----variables----------
Dim J As Byte                           'quickest lap #
Dim B As Byte                           'start of race
Dim X As Byte                           'number of overflows
Dim U As Byte                           ' lap #
Dim V As Byte                           'progress bar loop
Dim Z As Byte                           'seconds calc
Dim Sw As Byte                          'seconds calc
Dim Yy As Byte                          'rowlocation
Dim Ck As Byte                          'clock bitmap loop
Dim Avr As Byte                         'used to calc average speed
Dim Lapmrk As Integer                   'select lap marker
Dim D As Single                         'overflow calc
Dim Q As Single                         'eeprom storage
Dim M As Single                         'clock tic value
Dim Tot As Single                       'stat value holder
Dim Fastmax As Single                   'quickest lap
Dim Ee As Single                        'formatting holder
Dim K As String * 20                    'formatting string
Dim A As Word                           'capture value
Dim T As Word                           'eeprom  end location
Dim L As Word                           'eeprom location
Dim C As Word                           'intger calc
Dim Y As Word                           'minutes holder
Dim R As Word                           'eeprom storage
Dim Sp As Word                          'integer calc
Dim Sk As Word                          'minute calc
Dim F As Bit
Dim Ww As Bit                           'clock  bitmap cancel
'----------------------

'--initialize values---
X = 0
B = 0
M = .000256                             'one tic time
T = 4
U = 1
Yy = 1
Fastmax = 2000                          'must be greater than first lap
Lapmrk = -1                             'zero=no marker
'-----------------------
Waitms 500                              'wait for dispaly to clear
Cursor Off                              'turn dispaly cursor off
Showpic 0 , 0 , Flag                    'dispaly flag bitmap
Wait 5                                  'let flag bitmap be seen
Cls
'-----lap marker--------
Showpic 0 , 0 , Lapmrk                  'show lap text
Locate 7 , 8
Lcd "**"
While Pind.2 = 1                        'wait for button push
Wend
Do
Lapmrk = Lapmrk + 1                     'store lap mark
Locate 7 , 8
Lcd Lapmrk                              'print lap selection
Wait 1
If Pind.2 = 1 Then                      'done lap selection
 Goto Lapdon
End If
Loop
Lapdon:
Cls
 Waitms 500
'-----------------------
'----beam detection-----
Showpic 0 , 0 , Laser                   'show laer bitmap
While Pind.6 = 0                        'wait for beam detection
Wend
Cls
Waitms 500
Showpic 0 , 0 , Alaser                  'show second laser bitmap
Redue:
Showpic 0 , 105 , Pbar                  'show progress-bar bitmap
For V = 32 To 96 Step 32                '-this will provide progress-
   Wait 1
   Showpic V , 105 , Pseg
   Wait 1
Next V                                  '-----------------------------
If Pind.6 = 0 Then                      'check for beam again
   Showpic 0 , 105 , Clear
   Goto Redue                           're-do if no beam
Else                                    'beam still present
   Cls
   Waitms 500
   Showpic 0 , 0 , Srace                'show ready bitmap
End If
'-----------------------

'---enable interrupts---
Set Tifr.5                              'clear int0 flag
Set Gifr.6                              'clear capture flag
Enable Capture1
Enable Timer1
Enable Int0
Enable Interrupts
'-----------------------

'-----main loop---------
Do
If B = 1 Then                           'check for first complete lap
   For Ck = 0 To 128                    'clock bitmap scroll loop
   If Ww = 1 Then                       'shut-off clock bitmap when-
     Goto Ck1                           'in review mode
   End If
   Showpic 112 , Ck , Clock
   If Pind.6 = 0 Then
   Gosub Laser_fail                     'beam fault detection
   End If
   Waitms 100
   Next Ck
End If
Ck = 0
Ck1:
Loop
'-----------------------
End

'----beam broken-----
Isr_cap1:
A = Capture1                            ' save capture value from timer one
D = X                                   'save number of timer overflows
Timer1 = 0                              'reset timer
X = 0                                   'reset overflow counter
If B = 0 Then                           'check for first beam break
  B = 1                                 'toggle b1 to indicate start of session
  Cls
  Waitms 500
  Showpic 0 , 0 , Lptm                  'show lap and time header
  Goto Lapgo                            'skip for first beam break
End If
Gosub Store                             'store lap info
Gosub Lap_print                         'print lap info
Lapgo:
Wait 3                                  'this will allow car to pass through beam
Set Tifr.5                              'clear capture flag
Return
'-----------------------

'----overflow couter----
Isr_tim1:                               'this will count 16.7 sec overflows
X = X + 1
Return
'-----------------------

'---stop/review/print---
Isr_int0:                               'this routine will stop/review/print session
Disable Capture1
Stop Timer1
Disable Int0
Porta.0 = 0
Cls
Ww = 1                                  'stop clock display
Waitms 500
Showpic 0 , 0 , Review                  'show review header
While Pind.2 = 1                        'wait for a second button push
Wend
Showpic 0 , 0 , Lptm                    'show lap time header
Yy = 1
U = 1
R = T
T = T - 4                               'remove extra location
For L = 4 To T Step 4
If Yy = 16 Then                         'check for lap 16
   Waitms 500                           'button debouncing
   While Pind.2 = 1                     'continue 15 laps at a time
   Wend
End If
Readeeprom Q , L                        'read eeprom value
Gosub Lap_print                         'print results
Porta.0 = 0                             'reset lap marker
Next L                                  'increment eeprom location
Lcd "END"                               'last lap
Waitms 500
While Pind.2 = 1                        'continue with button push
Wend
Gosub Get_average                       'print statistics
U = 1
L = 1
T = R
Waitms 500                              'more debouncing
Set Gifr.6                              'clear int0 flag
Enable Int0
Return

'----print lap info-----
Lap_print:                              'this will print 15 laps
Yy = Yy + 1                             'increment row location
If Yy = 17 Then                         'check if on last lcd row
   Yy = 2                               'set to row 2
   Cls
   Waitms 500                           'cls screen and print the next 15 laps
   Showpic 0 , 0 , Lptm
End If

If Q >= 60 Then                         'check if lap >= a minute
 C = Q                                  'convert to integer
 Z = C Mod 60                           'get seconds over minute
 Y = C \ 60                             'get minutes
 Q = Q - C                              'get decimal value
 Q = Q + Z                              'add seconds to decimal value
 K = Str(q)                             'convert to string
    If Z <= 9 Then                      '--print routine for seconds<9--
     K = Left(k , 4)
     Locate Yy , 2
     Lcd U ; "     "
     Locate Yy , 6
     Lcd Y ; ":0" ; K
     Print "LAP " ; U ; " TIME " ; Y ; ":0" ; K
    Else                                '--------------------------------
     K = Left(k , 5)                    '--print routine for seconds>9---
     Locate Yy , 2
     Lcd U ; "     "
     Locate Yy , 6
     Lcd Y ; ":" ; K
     Print "LAP " ; U ; " TIME " ; Y ; ":" ; K
    End If                              '--------------------------------
 Goto Cash
End If
C = Q                                   '----print lap < than a minute----
K = Str(q)
    If C <= 9 Then
     K = Left(k , 4)
     Locate Yy , 2
     Lcd U ; "     "
     Locate Yy , 6
     Lcd "0:0" ; K
     Print "LAP " ; U ; " TIME " ; "0:0" ; K
    Else
     K = Left(k , 5)
     Locate Yy , 2
     Lcd U ; "     "
     Locate Yy , 6
     Lcd "0:" ; K
     Print "LAP " ; U ; " TIME " ; "0:" ; K
    End If                              '----------------------------------
Cash:
If U = Lapmrk Then
   Porta.0 = 1
   End If
U = U + 1                               'increment lap number
Return
'-----------------------
'----store to eeprom----
Store:                                  'this routine will store the lap vale in seconds
Q = M * A                               'convert timer value into seconds
D = D * 16.7                            'get total overflow seconds
Q = Q + D                               'this equals total seconds

If Q < Fastmax Then                     'check for quickest lap
   Fastmax = Q
   J = T / 4                            'calculate current quickest lap #
End If
If T > 500 Then                         'skip store when eeprom full
   Goto Full
Else
   Writeeeprom Q , T                    'write to eeprom
   T = T + 4                            'increment to next eeprom location
End If
Full:
Return
'-----------------------

'--print session stats--
Get_average:
For L = 4 To T Step 4                   'step to the total # of eeprom stored laps
Readeeprom Q , L                        'read total seconds from eeprom
Tot = Tot + Q                           'this is the total race seconds
Incr Avr                                'used to calculate average
Next L                                  'move to next eeprom location
Cls
Waitms 500
Locate 1 , 1
Lcd "TOTAL RACE TIME"
Locate 2 , 1
If Tot < 60 Then                        'print total race time
   Gosub Indy2                          'routine to print time < 60
Else
   Gosub Indy                           'routine to print time > 60
End If
Print "TOTAL RACE TIME> " ; Sk ; ":" ; K
Locate 4 , 1
Lcd "TOTAL # OF LAPS"
Locate 5 , 1
Lcd Avr                                 'total # of laps
Print "TOTAL # OF LAPS> " ; Avr
Locate 7 , 1
Lcd "AVERAGE LAP TIME"
Tot = Tot \ Avr                         'average time calc
Locate 8 , 1
If Tot < 60 Then
   Gosub Indy2
Else
   Gosub Indy
End If
Print "AVERAGE LAP TIME> " ; Sk ; ":" ; K
Locate 10 , 1
Lcd "QUICKEST LAP "
Tot = Fastmax                           'quickest lap to "tot"
Locate 11 , 1
If Tot < 60 Then
   Gosub Indy2
Else
   Gosub Indy
End If
Locate 11 , 10
Lcd "#" ; J
Print "QUICKEST LAP> " ; "#" ; J ; " " ; Sk ; ":" ; K
Tot = 0                                 'reset values
Avr = 0
Showpic 25 , 88 , F1                    'print f1 car
Return

'--format for time >60 sec-
Indy:                                   'routine to convert time >60 sec
Ee = Tot
Sp = Ee                                 'convert to integer
Sk = Sp \ 60                            '#of min
Sw = Sp Mod 60                          '#of sec
Ee = Ee - Sp                            'get decimal point
Ee = Ee + Sw                            'add decimal to seconds
K = Str(ee)                             'convert to string
If Sw <= 9 Then                         'used when seconds <9
   K = Left(k , 4)
   Lcd Sk ; ":0" ; K
Else
   K = Left(k , 5)                      'used when seconds>9
   Lcd Sk ; ":" ; K
End If
Return
'--------------------------

'-format for time < 60 sec-
Indy2:                                  'routine to convert time<60 sec
Sk = 0                                  'reset minute value
K = Str(tot)
If Tot <= 9 Then
   K = Left(k , 4)
   Lcd Sk ; ":0" ; K
Else
   K = Left(k , 5)
   Lcd Sk ; ":" ; K
End If
Return
'-------------------------

'----laser fail routine---
Laser_fail:
Ww = 1                                  'disable clock bitmap
If Fastmax = 2000 Then                  'reset if no lap was recorded
   Fastmax = 0
End If
Disable Capture1
Cls
Waitms 500
Showpic 0 , 0 , Laserfail               'dispaly laser bitmap
Return

Flag:                                   'flag file
$bgf "FlagPic.bgf"

F1:
$bgf "F1.bgf"                           'f1 car file

Laser:
$bgf "laser.bgf"                        'align laser file

Alaser:
$bgf "Alaser.bgf"                       'laser aligned file

Srace:
$bgf "start.bgf"                        'start file

Review:                                 'review text file
$bgf "review.bgf"

Clock:                                  'moving clock file
$bgf "clock.bgf"

Lptm:                                   'lap time text file
$bgf "lptm.bgf"

Pbar:                                   'progress bar file
$bgf "pbar.bgf"

Pseg:                                   'segment file
$bgf "pseg.bgf"

Clear:                                  'clear progress bar file
$bgf "clear.bgf"

Laserfail:                              'laser fail file
$bgf "laserfail.bgf"

Lapmrk:                                 'lap marker text
$bgf "lapmrk.bgf"